%global realname riak_core
%global upstream basho
%global debug_package %{nil}
%global git_tag b1c3778
%global patchnumber 0


Name:		erlang-%{realname}
Version:	1.2.1
Release:	3.p1%{?dist}
Summary:	Distributed systems infrastructure used by Riak
Group:		Development/Languages
License:	ASL 2.0
URL:		https://github.com/basho/riak_core
# wget --content-disposition https://github.com/basho/riak_core/tarball/1.2.1p1
Source0:	%{upstream}-%{realname}-%{version}p1-%{patchnumber}-g%{git_tag}.tar.gz
# Fedora/EPEL specific
Patch1:		erlang-riak_core-0001-Remove-checking-for-specific-version-of-libraries.patch
# Cherry-picked from RabbitMQ sources and sent upstream - https://github.com/basho/riak_core/pull/187
Patch2:		erlang-riak_core-0002-global-safe_whereis_name-1-has-been-removed.patch
# Sent upstream - https://github.com/basho/riak_core/pull/188
Patch3:		erlang-riak_core-0003-remove-duplicated-include.patch
# Sent upstream - https://github.com/basho/riak_core/pull/188
Patch4:		erlang-riak_core-0004-Guard-all-unguarded-eunit-includes.patch
# Fedora/EPEL specific
Patch5:		erlang-riak_core-0005-Explicitly-export-riak_core_ring_manager-set_ring_gl.patch

# Required for unit-tests only (if you're not interested in a compile-time
# testing then you may remove these lines):
BuildRequires:	erlang-basho_stats
BuildRequires:	erlang-cluster_info
BuildRequires:	erlang-folsom
BuildRequires:	erlang-lager
BuildRequires:	erlang-mochiweb
BuildRequires:	erlang-poolboy
BuildRequires:	erlang-riak_sysmon

# Compile-time requirements
BuildRequires:	erlang-meck >= 0.7.2
BuildRequires:	erlang-rebar
BuildRequires:	erlang-protobuffs >= 0.7.0
BuildRequires:	erlang-webmachine

# Error:erlang(dtrace:init/0)
# Error:erlang(dtrace:put_utag/1)
Requires:	erlang-basho_stats%{?_isa}
Requires:	erlang-cluster_info%{?_isa}
Requires:	erlang-crypto%{?_isa}
# Error:erlang(erlang:atom_to_binary/2) in R12B and below
# Error:erlang(erlang:binary_to_atom/2) in R12B and below
# Error:erlang(erlang:max/2) in R12B and below
# Error:erlang(erlang:min/2) in R12B and below
# Error:erlang(lists:keyfind/3) in R12B and below
# Error:erlang(os:timestamp/0) in R12B and below
Requires:	erlang-erts%{?_isa} >= R13B
Requires:	erlang-eunit%{?_isa}
Requires:	erlang-folsom%{?_isa}
Requires:	erlang-inets%{?_isa}
Requires:	erlang-kernel%{?_isa}
Requires:	erlang-lager%{?_isa}
Requires:	erlang-mochiweb%{?_isa}
Requires:	erlang-poolboy%{?_isa}
Requires:	erlang-protobuffs%{?_isa}
Requires:	erlang-riak_sysmon%{?_isa}
# Error:erlang(dyntrace:p/0) in R14B and below
# Error:erlang(dyntrace:put_tag/1) in R14B and below
Requires:	erlang-runtime_tools%{?_isa} >= R15B
# Error:erlang(ssl:ssl_accept/3) in R12B and below
Requires:	erlang-ssl%{?_isa} >= R13B
# Error:erlang(supervisor:count_children/1) in R12B and below
Requires:	erlang-stdlib%{?_isa} >= R13B
Requires:	erlang-webmachine%{?_isa}


%description
Distributed systems infrastructure used by Riak.


%prep
%setup -q -n %{upstream}-%{realname}-8d6d4ff
%patch1 -p1 -b .dont_check_for_libs
%patch2 -p1 -b .r15b01
%patch3 -p1 -b .duplicated_unguarded_eunit_include
%patch4 -p1 -b .guard_all_eunit_include
%patch5 -p1 -b .reexport


%build
rebar compile -v


%install
mkdir -p %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/{ebin,include,priv}
install -p -m 644 ebin/%{realname}.app %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin
install -p -m 644 ebin/*.beam %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/ebin
install -p -m 644 include/*.hrl %{buildroot}%{_libdir}/erlang/lib/%{realname}-%{version}/include


%check
rebar eunit -v


%files
%dir %{_libdir}/erlang/lib/%{realname}-%{version}
%dir %{_libdir}/erlang/lib/%{realname}-%{version}/ebin
%dir %{_libdir}/erlang/lib/%{realname}-%{version}/include
%{_libdir}/erlang/lib/%{realname}-%{version}/ebin/%{realname}.app
%{_libdir}/erlang/lib/%{realname}-%{version}/ebin/*.beam
%{_libdir}/erlang/lib/%{realname}-%{version}/include/*.hrl


%changelog
* Sat Oct 20 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.2.1-3.p1
- Ver. 1.2.1p1

* Fri Oct 19 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.2.1-2
- Rebuild with new lager

* Wed Oct 10 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.2.1-1
- Ver. 1.2.1

* Wed Sep 05 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.2.0-1
- Ver. 1.2.0

* Thu Jul 19 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.1.2-3
- Re-export one handy function

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri May 18 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.1.2-1
- Ver. 1.1.2

* Fri Feb 25 2011 Peter Lemenkov <lemenkov@gmail.com> - 0.14.1-1
- Ver. 0.14.1

* Sat Jan 22 2011 Peter Lemenkov <lemenkov@gmail.com> - 0.14.0-1
- Ver. 0.14.0
- Dropped upstreamed patch

* Fri Nov 12 2010 Peter Lemenkov <lemenkov@gmail.com> - 0.13.0-1
- Initial build

